;3DMesh/PFace/Surface -> 3D Points
;2009 by CAD Studio - www.cadstudio.cz  www.cadforum.cz
;; -----------------------------------------------------
(defun C:Mesh2Pt ( / Ent Obj ptList oDoc mSpace)

  (defun GetCoordinates (obj / objname coord lst)
    (and
      (setq objname (vlax-get obj 'ObjectName))
      (vl-position objname '("AcDbPolyFaceMesh" "AcDbSubDMesh" "AcDbPolygonMesh"
                             ))
      (setq coord (vlax-get obj 'Coordinates))
          (repeat (/ (length coord) 3)
            (setq lst (cons (list (car coord) (cadr coord) (caddr coord)) lst))
            (setq coord (cdddr coord))
          )
    ) ;and
    (reverse lst)
  ) ;end

 (vl-load-com)
 (setq oDoc (vla-get-ActiveDocument (vlax-get-acad-object)))
 (setq mSpace (vla-get-ModelSpace oDoc))
 (setq Ent (entsel "\nSelect a 3D mesh, polymesh or surface: "))
 (setq Obj (vlax-ename->vla-object (car Ent)))
 (setq ptList (GetCoordinates Obj))
 (mapcar '(lambda (x)(vla-AddPoint mSpace (vlax-3D-Point (trans x 1 0)))) ptList)
 (princ (strcat "\nCreated "(itoa (length ptList)) " 3D points."))
 (prin1)
)